#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "global.h"
#include "rand.h"

/* Filter out the nondominated solutions in the mixed population */
int Filter_Nondominated (population *mixed_pop, population *nondominated_pop)
{
	int i;
	int no_nondominated;

	individual *ind;

	no_nondominated = 0;

	for (i = 0; i < 2 * popsize; i++)
	{
		ind = &(mixed_pop->ind[i]);

		if (ind->fitness < 1.0)
		{
			copy_ind (&(mixed_pop->ind[i]), &(nondominated_pop->ind[no_nondominated]));
			no_nondominated++;
		}
	}

	return no_nondominated;
}

/* Decide whether these two individuals are the same, if they are not the same: return 1, otherwise return 0 */
int IsDifferent (individual *ind1, individual *ind2)
{
	int i;
	int flag;

	flag = 0;

	for (i = 0; i < nobj; i++)
	{
		if (ind1->obj[i] != ind2->obj[i])
		{
			flag = 1;
			break;
		}
	}

	return flag;
}

/* Filter out the not elite nondominated solutions */
void Filter_Unelite (population *nondominated_pop, population *archive, population *jumping_pop, int no_nondominated)
{
	int i, j;
	int flag;
	int jump_size;
	int correct;

	correct = no_nondominated - popsize;
	jump_size = 0;

	for (i = 0; i < no_nondominated; i++)
	{
		for (j = 0; j < archive_size; j++)
		{
			flag = IsDifferent (&(nondominated_pop->ind[i]), &(archive->ind[j]));
			if (flag == 0)
			{
				break;
			}
		}

		if (flag == 1)
		{
			copy_ind (&(nondominated_pop->ind[i]), &(jumping_pop->ind[jump_size]));
			jump_size++;
		}
	}

	if (jump_size != correct)
	{
		printf ("ERROR OCCUR!!!");
	}
}