#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "global.h"

void gd_igd_wfg (population *pop, int front_size)
{
	FILE *PF, *outFile1, *outFile2;
	int i, j;
	int t_point;	/* WFG2ĵȡ2314,10001 */
	double pf[10001][2];
	double d, sum;
	double gd, igd;
	double dis_min;

	d = 0.0;
	sum = 0.0;
	t_point = 10001;

	outFile1 = fopen ("wfg_gd.txt", "a");
	outFile2 = fopen ("wfg_igd.txt", "a");

	if ((PF = fopen (".//PF_Data//wfg9_PF.txt", "r")) == NULL)
	{
		printf ("the file open failed!");
		exit(1);
	}

	i = 0;
	j = 0;
	
	while (!feof (PF) && i < t_point)
	{
		j = 0;
		fscanf (PF, "%lf", &pf[i][j]);
		j = 1;
		fscanf(PF, "%lf", &pf[i][j]);
		i = i + 1;
	}

	for (i = 0; i < front_size; i++)
	{
		dis_min = INF;
		for (j = 0; j < t_point; j++)
		{
			d = sqrt ((pop->ind[i].obj[0] - pf[j][0]) * (pop->ind[i].obj[0] - pf[j][0]) +
				(pop->ind[i].obj[1]-pf[j][1])*(pop->ind[i].obj[1]-pf[j][1]));
			if (d < dis_min)
			{
				dis_min = d;
			}
		}
		sum += dis_min*dis_min;
	}

	gd = sqrt (sum) / front_size;
	fprintf (outFile1, "%lf\n", gd);

	d = 0.0;
	sum = 0.0;
	for (i = 0; i < t_point; i++)
	{
		dis_min = INF;
		for (j = 0; j < front_size; j++)
		{
			d = sqrt ((pf[i][0] - pop->ind[j].obj[0]) * (pf[i][0] - pop->ind[j].obj[0]) +
				(pf[i][1] - pop->ind[j].obj[1]) * (pf[i][1] - pop->ind[j].obj[1]));
			if (d < dis_min)
			{
				dis_min = d;
			}
		}
		sum += dis_min;
	}
	
	igd = sum / t_point;


	fprintf (outFile2, "%lf\n", igd);

	fclose (PF);
	fclose (outFile1);
	fclose (outFile2);
}

/* GD & IGD for UF(CEC 2009) */
void gd_igd_uf (population *pop, int front_size)
{
	FILE *PF,*outFile1,*outFile2;
	int i, j, k;
	int t_point;		/* UF1-UF7ĵȡ1000,UF521㣻UF8-UF10ȡ10000 */
	double pf[10000][3];
	double d, sum;
	double gd,igd;
	double dis_min;

	d = 0.0;
	sum = 0.0;
	t_point = 1000;

	outFile1 = fopen ("uf_gd.txt", "a");
	outFile2 = fopen ("uf_igd.txt", "a");
	if ((PF = fopen (".//PF_Data_UF//UF1.dat", "r")) == NULL)
	{
		printf ("the file open failed!");
		exit (1);
	}

	i = 0;
	j = 0;
	
	while (!feof (PF) && i < t_point)
	{
		j = 0;
		fscanf (PF, "%lf", &pf[i][j]);
		j = 1;
		fscanf (PF, "%lf", &pf[i][j]);
		if (nobj == 3)
		{
			j = 2;
			fscanf (PF, "lf", &pf[i][j]);
		}
		i = i + 1;
	}

	for (i = 0; i < front_size; i++)
	{
		dis_min = INF;
		for (j = 0; j < t_point; j++)
		{
			d = 0;
			for (k = 0; k < nobj; k++)
			{
				d += ((pop->ind[i].obj[k] - pf[j][k]) * (pop->ind[i].obj[k] - pf[j][k]));
			}
	
			d = sqrt (d);
			if (d < dis_min)
			{
				dis_min = d;
			}
		}
		sum += dis_min * dis_min;
	}

	gd = sqrt (sum) / front_size;
	
	fprintf (outFile1, "%lf\n", gd);

	d = 0.0;
	sum = 0.0;
	for (i = 0; i < t_point; i++)
	{
		dis_min = INF;
		for (j = 0; j < front_size; j++)
		{
			d = 0;
			for (k = 0; k < nobj;k++)
			{
				d += ((pf[i][k] - pop->ind[j].obj[k]) * (pf[i][k] - pop->ind[j].obj[k]));
			}

			d = sqrt (d);
			if (d < dis_min)
			{
				dis_min = d;
			}
		}
		sum += dis_min;
	}
	
	igd = sum / t_point;
	fprintf (outFile2, "%lf\n", igd);

	fclose (PF);
	fclose (outFile1);
	fclose (outFile2);
}
