/* spea2 routine (implementation of the 'main' function) */
/* revised by Luobiao and Wujun */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>
# include "time.h"
# include "global.h"
# include "rand.h"

int k;
int l;
int nreal;
int nobj;
int popsize;
int archive_size;
double pcross_real;
double pmut_real;
double eta_c;
double eta_m;
int Max_Gen;
int nrealmut;
int nrealcross;
double *min_realvar;
double *max_realvar;
double *min_pf;				/* Pareto frontmininmal߽ */
double *max_pf;				/* Pareto frontmaximal߽ */

long start,end; 
double time1;

/* 14/12/2010 */
double jumping_percentage;	// ȷtransposonı
int no_trans;				// transposon
double jumping_rate;		// 趨jumpingı
int jumping_count;			// jumping

/* 14/12/2010 */
int stop_index;				// ʾjumpingȺλ

dimension = 2;

// const double reference[] = {3.0, 5.0};		/* WFG test suits */
// const double reference[] = {2.0, 2.0};			/* ZDT test suits */
// const double reference[] = {1.0, 1.0, 1.0};	/* DTLZ1 test suits */
 const double reference[] = {2.0, 2.0, 2.0};  /* DTLZ others test suits */
// const double reference[] = {2.0, 2.0, 7.0};  /* DTLZ7 test suits */

int main (int argc, char **argv)
{
    int i, j;
	int ngen;				/* the number of generations */
	int Max_times;			/* the number of running times */
    
	/* 2010/12/28 */
	int round;
	char path[50];
	double increment_rate;
	double increment_percentage;

	/* 2010/12/28 */
	FILE *outfpt ;
	FILE *fpt1;				/* SP */
	FILE *fpt2;				/* MS */
	FILE *fpt3;				/* Record GD from WFG */
	FILE *fpt4;				/* Record IGD from WFG */
	FILE *fpt5;				/* Record GD from ZDT3 */
	FILE *fpt6;				/* Record GD from DTLZ7 */

	double pruning = 0;

    population *parent_pop;
    population *child_pop;
    population *mixed_pop;
	population *archive;
	
	int random;
	double mux;

	/* MS parameters */
	double sum_ms;
	double mean_ms;
	double variance_ms;
	/* SP parameters */
	double sum_sp;
	double mean_sp;
	double variance_sp;
	/* UA parameters */
	double sum_ua;
	double mean_ua;
	double variance_ua;
	/* GD parameters */
	double sum_gd;
	double mean_gd;
	double variance_gd;
	/* IGD parameters */
	double sum_igd;
	double mean_igd;
	double variance_igd;
	/* Hypervolume parameters */
	double sum_hv;
	double mean_hv;
	double variance_hv;

	/* performance value array */
	double *sp_array;
	double *ms_array;
	double *ua_array;
	double *gd_array;
	double *igd_array;
	double *hv_array;
	
	/* 14/12/2010 */
	int jump_size;
	int jumped_size;
	population *jumping_pop;
	population *jumped_pop;
	population *jumped_mixed_pop;
	population *actual_jumped_pop;
	
	srand ((unsigned) time (NULL)); 
	random = rand () % 1000;
    seed = (float) random / 1000.0;

	popsize = 100;
	Max_Gen = 300;
	Max_times = 50;
    nobj = 3;
    nreal = 12;
	k = 2;
	l = 4;
	//nreal = k + l;

	/* 2010/12/28 */
	increment_rate = 0.05;
	increment_percentage = 0.1;

	archive_size = popsize;

	/* 14/12/2010 */
	jumping_rate = 0.05;
	jumping_percentage = 0.1;
	
	for( ;jumping_rate <= 1.0 || jumping_percentage <= 1.0; )
	{
		srand ((unsigned) time (NULL)); 
		random = rand () % 1000;
		seed = (float) random / 1000.0;

		round = 1;
		printf ("%lf\t%lf\n", jumping_percentage, jumping_rate);

		sprintf (path, ".\\\\data\\Percentage = %.1lf\\%.2lf.txt", jumping_percentage, jumping_rate);
		outfpt = fopen (path, "w");
		if (outfpt == NULL)
			ERROR ("File Open Error!");

		no_trans = ceil (jumping_percentage * nreal);

		/* ڴ */
		sp_array = (double *) malloc (Max_times * sizeof (double));
		if (!sp_array)
			ERROR ("'sp_array' memory allocation failed!");
		ms_array = (double *) malloc (Max_times * sizeof (double));
		if (!ms_array)
			ERROR ("'ms_array' memory allocation failed!");
		ua_array = (double *) malloc (Max_times * sizeof (double));
		ua_array = (double *) malloc (Max_times * sizeof (double));
		if (!ua_array)
			ERROR ("'ua_array' memory allocation failed!");
		gd_array = (double *) malloc (Max_times * sizeof (double));
		if (!gd_array)
			ERROR ("'igd_array' memory allocation failed!");
		igd_array = (double *) malloc (Max_times * sizeof (double));
		if (!igd_array)
			ERROR ("'igd_array' memory allocation failed!");
		hv_array = (double *) malloc (Max_times * sizeof (double));
		if (!hv_array)
			ERROR ("'hv_array' memory allocation failed!");

//////////////////////////////////////////////////////////////////////////
		/*  the boundary of problems
		SCH1(0_4) SCH2(-1_1, 0_16) FON1(0_1) FON2(0_0.97936) KUR(-20_-14.44666, -11.62641_0) POL(-16.80819_-1, -24.98058_0)
		VNT1(0_4, 1_5, 2_4) VNT2(3_4.25082, -17_-16.47494, -13_-12.05311) VNT3(0_8.19641, 15_17.03704, -0.1_0.17604)
		ZDT3(0_0.85179, -0.77337_1) ZDT6(0.2807_1, 0_0.92121) others ZDT(0_1, 0_1);
		DTLZ1(0_0.5, 0_0.5, 0_0.5) DTLZ5,DTLZ6(0_0.70711, 0_0.70711, 0_1), DTLZ7(0_0.86, 0_0.86, 2.61404_6) others DTLZ(0_1, 0_1, 0_1)
		WFG(all 0_2, 0_4) */
		
		min_pf = (double *) malloc (nobj * sizeof(double));
		max_pf = (double *) malloc (nobj * sizeof(double));

		/*for (i = 0; i < nobj; i++)
		{
			min_pf[i] = 0.0;
			max_pf[i] = 0.5;
		}*/
		min_pf[0] = 0.0;
		max_pf[0] = 0.70711;
		min_pf[1] = 0.0;
		max_pf[1] = 0.70711;
		min_pf[0] = 0.0;
		max_pf[1] = 1.0;
//////////////////////////////////////////////////////////////////////////
		
		if (nreal != 0)
		{
			min_realvar = (double *) malloc (nreal * sizeof(double));	/* ڴ洢Ӧʵ */
			max_realvar = (double *) malloc (nreal * sizeof(double));	/* ڴ洢Ӧʵ */
	        
			/* WFG parameter scale */
			/*min_realvar[0] = 0.0;
			max_realvar[0] = 2.0;
			for (i = 1; i < nreal; i++)
			{
				min_realvar[i] = 0.0;
				max_realvar[i] = 2.0 * (i + 1);
			}*/	

			/* normal test suits scale */
			min_realvar[0] = 0.0;
			max_realvar[0] = 1.0;
			for (i = 1; i < nreal; i++)
			{
				min_realvar[i] = 0.0;
				max_realvar[i] = 1.0;
			}

			pcross_real = 0.9;		// ʵĽ(0.6-1.0) 
			if (pcross_real < 0.0 || pcross_real > 1.0)
			{
				printf ("\n Probability of crossover entered is : %e", pcross_real);
				printf ("\n Entered value of probability of crossover of real variables is out of bounds, hence exiting \n");
				exit (1);
			}

			pmut_real = 1.0 / nreal;	// ʵı(1/nreal)
			if (pmut_real < 0.0 || pmut_real > 1.0)
			{
				printf ("\n Probability of mutation entered is : %e", pmut_real);
				printf ("\n Entered value of probability of mutation of real variables is out of bounds, hence exiting \n");
				exit (1);
			}
	    
			//eta_c = 10.0;				/* WFG setting */
			eta_c = 20.0;				// ֲϵ(5-20һȡ10)
			if (eta_c <= 0)
			{
				printf ("\n The value entered is : %e", eta_c);
				printf ("\n Wrong value of distribution index for crossover entered, hence exiting \n");
				exit (1);
			}

			//eta_m = 50.0;				/* WFG setting */
			eta_m = 20.0;				// ֲϵ(5-50һȡ10)
			if (eta_m <= 0)
			{
				printf ("\n The value entered is : %e", eta_m);
				printf ("\n Wrong value of distribution index for mutation entered, hence exiting \n");
				exit (1);
			}
		}
	    
//////////////////////////////////////////////////////////////////////////
		jumping_pop = (population *) malloc (sizeof(population));
		jumped_pop = (population *) malloc (sizeof(population));
		jumped_mixed_pop = (population *) malloc (sizeof(population));
		actual_jumped_pop = (population *) malloc (sizeof(population));
//////////////////////////////////////////////////////////////////////////

		printf("\n Input data successfully entered, now performing initialization \n");
		nrealmut = 0;
		nrealcross = 0;
		parent_pop = (population *) malloc (sizeof(population));
		child_pop = (population *) malloc (sizeof(population));
		mixed_pop = (population *) malloc (sizeof(population));
		archive = (population *) malloc (sizeof(population));
		allocate_memory_pop (parent_pop, popsize);
		allocate_memory_pop (child_pop, popsize);
		allocate_memory_pop (mixed_pop, 2 * popsize);
		allocate_memory_pop (archive, archive_size);
		randomize ();

		start = clock ();         // ʼʱ
		printf("\n Starting time : %ld \n", start);

		fflush (stdout);
		fflush (outfpt);

		for (i = 0; i < Max_times; i++)
		{
			initialize_pop (parent_pop);
			printf ("\n Initialization done, now performing round %d", round);
			round++;
			evaluate_pop (parent_pop, popsize);	
			copy_pop (parent_pop, archive, archive_size);
			
			for (ngen = 2; ngen < Max_Gen; ngen++)
			{
				evaluate_pop (parent_pop, popsize);
				merge (parent_pop, popsize, archive, archive_size, mixed_pop);
				calcFitnesses (mixed_pop, popsize + archive_size);
				jump_size = environmentalSelection_jump (mixed_pop, popsize + archive_size, archive, archive_size, &pruning, jumping_pop);

				/* 14/12/2010 */
//////////////////////////////////////////////////////////////////////////
				if (jump_size > 0)
				{
					allocate_memory_pop (jumped_pop, 6 * jump_size);
					
					JumpingOperation (jumping_pop, archive, jumped_pop, jump_size);
					jumped_size = stop_index;
					allocate_memory_pop (actual_jumped_pop, jumped_size);
					for (j = 0; j < jumped_size; j++)
					{
						copy_ind (&jumped_pop->ind[j], &actual_jumped_pop->ind[j]);
					}
					/* 2010/12/24 */
					evaluate_pop (actual_jumped_pop, jumped_size);
					calcFitnesses_Jump (actual_jumped_pop, jumped_size);

					allocate_memory_pop (jumped_mixed_pop, archive_size + jumped_size);
					merge (archive, archive_size, actual_jumped_pop, jumped_size, jumped_mixed_pop);
					environmentalSelection (jumped_mixed_pop, archive_size + jumped_size, archive, archive_size, &pruning);

					deallocate_memory_pop (jumping_pop, jump_size);
					deallocate_memory_pop (jumped_pop, 6 * jump_size);
					deallocate_memory_pop (actual_jumped_pop, jumped_size);
					deallocate_memory_pop (jumped_mixed_pop, archive_size + jumped_size);
				}
//////////////////////////////////////////////////////////////////////////
				matingSelection (archive, archive_size, parent_pop, popsize);
			}
			merge (parent_pop, popsize, archive, archive_size, mixed_pop);
			calcFitnesses (mixed_pop, popsize + archive_size);
			jump_size = environmentalSelection_jump (mixed_pop, popsize + archive_size, archive, archive_size, &pruning, jumping_pop);
//////////////////////////////////////////////////////////////////////////
			if (jump_size > 0)
			{
				allocate_memory_pop (jumped_pop, 6 * jump_size);

				JumpingOperation (jumping_pop, archive, jumped_pop, jump_size);
				jumped_size = stop_index;
				allocate_memory_pop (actual_jumped_pop, jumped_size);
				for (j = 0; j < jumped_size; j++)
				{
					copy_ind (&jumped_pop->ind[j], &actual_jumped_pop->ind[j]);
				}
				/* 2010/12/24 */
				evaluate_pop (actual_jumped_pop, jumped_size);
				calcFitnesses_Jump (actual_jumped_pop, jumped_size);

				allocate_memory_pop (jumped_mixed_pop, archive_size + jumped_size);
				merge (archive, archive_size, actual_jumped_pop, jumped_size, jumped_mixed_pop);
				environmentalSelection (jumped_mixed_pop, archive_size + jumped_size, archive, archive_size, &pruning);

				deallocate_memory_pop (jumping_pop, jump_size);
				deallocate_memory_pop (jumped_pop, 6 * jump_size);
				deallocate_memory_pop (actual_jumped_pop, jumped_size);
				deallocate_memory_pop (jumped_mixed_pop, archive_size + jumped_size);
			}
//////////////////////////////////////////////////////////////////////////
			score_pop (archive);						/* SP & MS */
			ua_array[i] = uniform_diversity (archive);	/* UA */
			gd_array[i] = get_gd (archive);				/* GD */
			igd_array[i] = get_igd (archive);			/* IGD */
			//gd_igd_zdt3 (archive);					/* GD & IGD for ZDT3 */
			//gd_igd_dtlz7 (archive);					/* GD & IGD for DTLZ7 */
			//gd_igd_wfg (archive, archive_size);		/* GD & IGD for WFG */
			hv_array[i] = get_hv (archive);				/* Hypervolume */	
		}
		
		fpt1 = fopen ("sp.txt", "r");
		fpt2 = fopen ("new_ms.txt", "r");

		i = 0;
		while (fscanf (fpt1, "%lf", &sp_array[i]) != EOF)
		{
			i++;
		}
		i = 0;
		while (fscanf (fpt2, "%lf", &ms_array[i]) != EOF)
		{
			i++;
		}

		/*fpt3 = fopen ("wfg_gd.txt", "r");
		fpt4 = fopen ("wfg_igd.txt", "r");

		i = 0;
		while (fscanf (fpt3, "%lf", &gd_array[i]) != EOF)
		{
			i++;
		}
		i = 0;
		while (fscanf (fpt4, "%lf", &igd_array[i]) != EOF)
		{
			i++;
		}*/

		/*fpt5 = fopen ("gd.txt", "r");
		fpt6 = fopen ("igd.txt", "r");

		i = 0;
		while (fscanf (fpt5, "%lf", &gd_array[i]) != EOF)
		{
			i++;
		}
		i = 0;
		while (fscanf (fpt6, "%lf", &igd_array[i]) != EOF)
		{
			i++;
		}*/

		/* ͳSP */
		sum_sp = 0;
		fprintf (outfpt, "ͳSP\n");
		for (i = 0; i < Max_times; i++)
		{
			fprintf (outfpt, "%lf\n", sp_array[i]);
			sum_sp += sp_array[i];
		}
		mean_sp = sum_sp / Max_times;
		sum_sp = 0;
		for (i = 0; i < Max_times; i++)
		{
			sum_sp += pow ((sp_array[i] - mean_sp), 2.0);
		}
		variance_sp = sum_sp / Max_times;
		variance_sp = sqrt (variance_sp);
		fprintf (outfpt, "mean_SP = %e\nvariance_SP = %e\n", mean_sp, variance_sp);

		/* ͳMS */
		sum_ms = 0;
		fprintf (outfpt, "ͳMS\n");
		for (i = 0; i < Max_times; i++)
		{
			fprintf (outfpt, "%lf\n", ms_array[i]);
			sum_ms += ms_array[i];
		}
		mean_ms = sum_ms / Max_times;
		sum_ms = 0;
		for (i = 0; i < Max_times; i++)
		{
			sum_ms += pow ((ms_array[i] - mean_ms), 2.0);
		}
		variance_ms = sum_ms / Max_times;
		variance_ms = sqrt (variance_ms);
		fprintf (outfpt, "mean_MS = %e\nvariance_MS = %e\n", mean_ms, variance_ms);

		/* ͳUA */
		sum_ua = 0;
		fprintf (outfpt, "ͳUA\n");
		for (i = 0; i < Max_times; i++)
		{
			fprintf (outfpt, "%lf\n", ua_array[i]);
			sum_ua += ua_array[i];
		}
		mean_ua = sum_ua / Max_times;
		sum_ua = 0;
		for (i = 0; i < Max_times; i++)
		{
			sum_ua += pow ((ua_array[i] - mean_ua), 2.0);
		}
		variance_ua = sum_ua / Max_times;
		variance_ua = sqrt (variance_ua);
		fprintf (outfpt, "mean_UA = %e\nvariance_UA = %e\n", mean_ua, variance_ua);

		/* ͳGD */
		sum_gd = 0;
		fprintf (outfpt, "ͳGD\n");
		for (i = 0; i < Max_times; i++)
		{
			fprintf (outfpt, "%lf\n", gd_array[i]);
			sum_gd += gd_array[i];
		}
		mean_gd = sum_gd / Max_times;
		sum_gd = 0;
		for (i = 0; i < Max_times; i++)
		{
			sum_gd += pow ((gd_array[i] - mean_gd), 2.0);
		}
		variance_gd = sum_gd / Max_times;
		variance_gd = sqrt (variance_gd);
		fprintf (outfpt, "mean_GD = %e\nvariance_GD = %e\n", mean_gd, variance_gd);

		/* ͳIGD */
		sum_igd = 0;
		fprintf (outfpt, "ͳIGD\n");
		for (i = 0; i < Max_times; i++)
		{
			fprintf (outfpt, "%lf\n", igd_array[i]);
			sum_igd += igd_array[i];
		}
		mean_igd = sum_igd / Max_times;
		sum_igd = 0;
		for (i = 0; i < Max_times; i++)
		{
			sum_igd += pow ((igd_array[i] - mean_igd), 2.0);
		}
		variance_igd = sum_igd / Max_times;
		variance_igd = sqrt (variance_igd);
		fprintf (outfpt, "mean_IGD = %e\nvariance_IGD = %e\n", mean_igd, variance_igd);

		/* ͳHypervolume */
		sum_hv = 0;
		fprintf (outfpt, "ͳHypervolume\n");
		for (i = 0; i < Max_times; i++)
		{
			fprintf (outfpt, "%lf\n", hv_array[i]);
			sum_hv += hv_array[i];
		}
		mean_hv = sum_hv / Max_times;
		sum_hv = 0;
		for (i = 0; i < Max_times; i++)
		{
			sum_hv += pow ((hv_array[i] - mean_hv), 2.0);
		}
		variance_hv = sum_hv / Max_times;
		variance_hv = sqrt (variance_hv);
		fprintf (outfpt, "mean_Hypervolume = %e\nvariance_Hypervolume = %e\n", mean_hv, variance_hv);

		/* ֵ */
		printf (" SP = %lf\n", mean_sp);
		printf (" MS = %lf\n", mean_ms);
		printf (" UA = %lf\n", mean_ua);
		printf (" GD = %lf\n", mean_gd);
		printf (" IGD = %lf\n", mean_igd);
		printf (" Hypervolume = %lf\n", mean_hv);
		
		end = clock ();		
		time1 = (double) (end - start) / CLOCKS_PER_SEC;
		printf ("\n Ending time: %ld \n", end);	 
		printf ("\n The total time for running the routine is %f seconds !\n", time1);

		fflush (stdout);
		fclose (fpt1);
		fclose (fpt2);
		system ("del sp.txt");
		system ("del ms.txt");
		system ("del new_ms.txt");

		/*fclose (fpt3);
		fclose (fpt4);
		system ("del wfg_gd.txt");
		system ("del wfg_igd.txt");*/

		/*fclose (fpt5);
		fclose (fpt6);
		system ("del gd.txt");
		system ("del igd.txt");*/

		if (nreal != 0)
		{
			free (min_realvar);
			free (max_realvar);
		}
		free (min_pf);
		free (max_pf);

		free (sp_array);
		free (ms_array);
		free (ua_array);
		free (gd_array);
		free (igd_array);
		free (hv_array);

		deallocate_memory_pop (parent_pop, popsize);
		deallocate_memory_pop (mixed_pop, 2 * popsize);
		deallocate_memory_pop (archive, archive_size);
		free (parent_pop);
		free (mixed_pop);
		free (archive);

		free (jumping_pop);
		free (jumped_pop);
		free (jumped_mixed_pop);
		free (actual_jumped_pop);

		if( jumping_rate < 1.0 ) 
		{
			jumping_rate += increment_rate;
		}
		else 
		{
			jumping_rate = 0.05 ;
    		jumping_percentage += increment_percentage;
			if (jumping_percentage > 1.0)
			{
				break;
			}
		}
		fflush (outfpt);
		fclose (outfpt);
}
    printf ("\n Routine successfully exited! \n\a");	
}