/* Test problem definitions */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

// # define zdt1
// # define zdt2
// # define zdt3
// # define zdt4
/* # define zdt5 */
 # define zdt6 
// # define dtlz1  
// # define dtlz2    
// # define dtlz3  
// # define dtlz4 
// # define dtlz5
// # define dtlz6
// # define dtlz7

/*  Test problem ZDT1
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt1
void test_problem (double *xreal, double *obj)
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    
    for (i = 1; i < 30; i++)
    {
        g += xreal[i];
    }
    g = 9.0 * g / 29.0;
    g += 1.0;
    h = 1.0 - sqrt(f1 / g);
    f2 = g * h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif

/*  Test problem ZDT2
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt2
void test_problem (double *xreal, double *obj)
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    h = 1.0 - pow((f1/g),2.0);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif

/*  Test problem ZDT3
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt3
void test_problem (double *xreal, double *obj)
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    h = 1.0 - sqrt(f1/g) - (f1/g)*sin(10.0*PI*f1);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif

/*  Test problem ZDT4
    # of real variables = 10
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt4
void test_problem (double *xreal, double *obj)
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<10; i++)
    {
        g += xreal[i]*xreal[i] - 10.0*cos(4.0*PI*xreal[i]);
    }
    g += 91.0;
    h = 1.0 - sqrt(f1/g);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif

/*  Test problem ZDT5
    # of real variables = 0
    # of bin variables = 11
    # of bits for binvar1 = 30
    # of bits for binvar2-11 = 5
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt5
void test_problem (double *xreal, double *obj)
{
    int i, j;
    int u[11];
    int v[11];
    double f1, f2, g, h;
    for (i=0; i<11; i++)
    {
        u[i] = 0;
    }
    for (j=0; j<30; j++)
    {
        if (gene[0][j] == 1)
        {
            u[0]++;
        }
    }
    for (i=1; i<11; i++)
    {
        for (j=0; j<4; j++)
        {
            if (gene[i][j] == 1)
            {
                u[i]++;
            }
        }
    }
    f1 = 1.0 + u[0];
    for (i=1; i<11; i++)
    {
        if (u[i] < 5)
        {
            v[i] = 2 + u[i];
        }
        else
        {
            v[i] = 1;
        }
    }
    g = 0;
    for (i=1; i<11; i++)
    {
        g += v[i];
    }
    h = 1.0/f1;
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif

/*  Test problem ZDT6
    # of real variables = 10
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */

#ifdef zdt6
void test_problem (double *xreal, double *obj)
{
    double f1, f2, g, h;
    int i;

    f1 = 1.0 - (exp (-4.0 * xreal[0])) * pow ((sin (6.0 * PI * xreal[0])), 6.0);
    g = 0.0;

    for (i = 1; i < 10; i++)
    {
        g += xreal[i];
    }

    g = g / 9.0;
    g = pow (g, 0.25);
    g = 1.0 + 9.0 * g;
    h = 1.0 - pow ((f1 / g), 2.0);
    f2 = g * h;

    obj[0] = f1;
    obj[1] = f2;
    return;
}
#endif

/*  Test problem DTLZ1
    # of real variables = 7
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

#ifdef dtlz1
void test_problem (double *xreal, double *obj)
{

    double sum=0;
    double gx;
    int i;
    for(i = 2; i < nreal; i++)
        sum += (xreal[i] - 0.5) * (xreal[i] - 0.5) - cos(20 * PI * (xreal[i] - 0.5));
       gx = 100 * (sum + nreal - 3 + 1) + 1;
    obj[0] = 0.5 * xreal[0] * xreal[1] * gx;
    obj[1] = 0.5 * xreal[0] * (1 - xreal[1]) * gx;
    obj[2] = 0.5 * (1 - xreal[0]) * gx;
    return;
}
#endif

/*  Test problem DTLZ2
    # of real variables = 12
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

#ifdef dtlz2
void test_problem (double *xreal, double *obj)
{
    double p=3.1415926;
    double sum=0;
    double gx;
    int j;

    for (j = 2; j < nreal; j++)
        sum += (xreal[j] - 0.5) * (xreal[j] - 0.5);
    gx = sum + 1;

    obj[0] = cos(xreal[0] * p / 2) * cos(xreal[1] * p / 2) * gx;
    obj[1] = cos(xreal[0] * p / 2) * sin(xreal[1] * p / 2) * gx;
    obj[2] = sin(xreal[0] * p / 2) * gx;
}
#endif

/*  Test problem DTLZ5
    # of real variables = 12
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

/*  Test problem DTLZ23
    # of real variables = 12
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

#ifdef dtlz3
void test_problem (double *xreal, double *obj)
{
    double  p = 3.1415926;
    double  sum = 0;
    double gx;
    int j;

    for(j = 2; j < nreal; j++)
        sum += (xreal[j] - 0.5) * (xreal[j] - 0.5) - cos(20 * p * (xreal[j] - 0.5));
    gx = 100 * (sum + nreal - nobj + 1) + 1;
    obj[0] = cos(xreal[0] * p / 2) * cos(xreal[1] * p / 2) * gx;
    obj[1] = cos(xreal[0] * p / 2) * sin(xreal[1] * p / 2) * gx;
    obj[2] = sin(xreal[0] * p / 2) * gx;
}
#endif

/*  Test problem DTLZ4
    # of real variables = 12
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

#ifdef dtlz4
void test_problem (double *xreal, double *obj)
{
   double p = 3.1415926;
   double sum = 0;
   double gx;
   int j;

    for(j = 2; j < nreal; j++)
        sum += (xreal[j] - 0.5) * (xreal[j] - 0.5);
    for (j = 0; j < nobj - 1; j++)
        xreal[j] = pow(xreal[j], (float)10);
    gx = sum + 1;
    obj[0] = cos(xreal[0] * p / 2) * cos(xreal[1] * p / 2) * gx;
    obj[1] = cos(xreal[0] * p / 2) * sin(xreal[1] * p / 2) * gx;
    obj[2] = sin(xreal[0] * p / 2) * gx;
}
#endif

/*  Test problem DTLZ5
    # of real variables = 12
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

#ifdef dtlz5
void test_problem (double *xreal, double *obj)
{
//  double p = 3.1415926;
    double sum = 0;
    double g;
    double x[2];
    int i;
    for(i = 2; i < nreal; i++)
        sum += (xreal[i] - 0.5) * (xreal[i] - 0.5);
    for (i = 1; i < nobj - 1; i++)
        x[i] = PI / (4 * (1 + sum)) * (1 + 2 * sum * xreal[i]);
    g = sum + 1;
    
    obj[0] = cos (xreal[0] * PI / 2) * cos (x[1]) * g;
    obj[1] = cos (xreal[0] * PI / 2) * sin (x[1]) * g;
    obj[2] = sin (xreal[0] * PI / 2) * g; 
    return;
}
#endif

/*  Test problem DTLZ6
    # of real variables = 12
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

#ifdef dtlz6
void test_problem (double *xreal, double *obj)
{
    double p = 3.1415926;
    double sum = 0;
    double g;
    float x[2];
    int i;

    for (i = 2; i < nreal; i++)
        sum += pow (xreal[i], 0.1);
    for (i = 1; i < nobj - 1; i++)
        x[i] = p / (4 * (1 + sum)) * (1 + 2 * sum * xreal[i]);
    g = sum + 1;
    
    obj[0] = cos (xreal[0] * p / 2) * cos (x[1]) * g;
    obj[1] = cos (xreal[0] * p / 2) * sin (x[1]) * g;
    obj[2] = sin (xreal[0] * p / 2) * g; 
    return;
}
#endif

/*  Test problem DTLZ7
    # of real variables = 22
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */

#ifdef dtlz7
void test_problem (double *xreal, double *obj, double *constr)
{
    double p = 3.1415926;
    double g = 0, temp = 0;
    double h;
    float x[2];
    int i;
    
    for (i = 2; i < nreal; i++)
    {
        g += xreal[i];
    }
    g = 1 + 9 * g / (nreal - nobj + 1);
    
    obj[0] = xreal[0];
    obj[1] = xreal[1];
    for (i = 0; i < nobj - 1; i++)
    {
        temp += (obj[i] / (g + 1)) * (1 + sin (3 * p * obj[i]));
    }
    h = nobj - temp;
    
    obj[2] = (g + 1) * h;

    return;
}
#endif