# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

double Euclidean_Distance (individual *ind1, individual *ind2)
{
	int i;
	double d;

	d = 0.0;

	for (i = 0; i < nobj; i++)
	{
		d += pow((ind1->obj[i] - ind2->obj[i]), 2.0);
	}
	d = sqrt (d);
	
	return (d);
}

/* Insert an element X into the list at location specified by NODE */
void insert (list *node, int x)
{
    list *temp;
    if (node == NULL)
    {
        printf ("\n Error!! asked to enter after a NULL pointer, hence exiting \n");
        exit (1);
    }
    temp = (list *) malloc (sizeof(list));
    temp->index = x;
    temp->child = node->child;
    temp->parent = node;
    if (node->child != NULL)
    {
        node->child->parent = temp;
    }
    node->child = temp;
}

/* Delete the node NODE from the list */
list* del (list *node)
{
    list *temp;
    if (node == NULL)
    {
        printf ("\n Error!! asked to delete a NULL pointer, hence exiting \n");
        exit (1);
    }
    temp = node->parent;
    temp->child = node->child;
    if (temp->child != NULL)
    {
        temp->child->parent = temp;
    }
    free (node);

    return (temp);
}
