# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

double uniform_diversity (population *pop)
{
	double sp, sum, sum1, countsum, value, value2;
    int i, j, k, count1, count2;
	double temp, temp1, min2, valuesum;
	int *closest;
	int *b, *d;
	double **c;
	double *lowcost, *e;

	sum = 0;
	sum1 = 0;
	temp = 0;

	lowcost = (double *) malloc (archive_size * sizeof(double));
	closest = (int *) malloc (archive_size * sizeof(int));	
    
	b = (int *) malloc (archive_size * sizeof(int));
	d = (int *) malloc (archive_size * sizeof(int));
	e = (double *) malloc (archive_size * sizeof(double));

    c = (double **) malloc (archive_size * sizeof(double));
    
	for (i = 0; i < archive_size; i++)
    {
        c[i] = (double *) malloc (archive_size * sizeof(double));
    }
    for (i = 0; i < archive_size; i++)
	{   
		
		for (j = i + 1; j < archive_size; j++)
		{
			temp1 = 0;

		    for(k = 0; k < nobj; k++)
			{
				temp1 += (pop->ind[i].obj[k] - pop->ind[j].obj[k]) * (pop->ind[i].obj[k] - pop->ind[j].obj[k]);
			}
			
			temp1 = sqrt(temp1);
           
			c[i][j] = temp1;
            c[j][i] = temp1;
		}
		c[i][i] = INF;
	}
    
    for (i = 0; i < archive_size; i++)
    {
		lowcost[i] = c[0][i];
		closest[i] = 0;
	}
	closest[0] = -1;
	
	for (i = 0; i < archive_size-1; i++)
	{
		min2 = INF;
		k = 0;

        for (j = 0; j < archive_size; j++)
		{
			if (closest[j] != -1 && lowcost[j] < min2)
			{
				min2 = lowcost[j];
				k = j;
			}
		}
        if (k)
		{			
			b[i] = closest[k];
			d[i] = k;
			e[i] = min2;

			closest[k] = -1;
			for (j = 1; j < archive_size;j++)
			{
				if (closest[j] != -1 && c[k][j] < lowcost[j])
				{
					lowcost[j] = c[k][j];
					closest[j] = k;
				}
			}
		}
	}
	countsum = 0;
	valuesum = 0;
	for (i = 0; i < archive_size-1; i++)
	{   
		count1 = 0;
		count2 = 0;
		value = 1;
		value2 = 0;
		for (j = 0; j < archive_size; j++)
		{   
			if(c[b[i]][j] < e[i])
			{
				value *= (c[b[i]][j] / e[i]);
				count1++;
			}
			if (c[d[i]][j] < e[i])
			{
				value *= (c[d[i]][j] / e[i]);
				count2++;
				value2 = 1;
			}
		}
		if (count1 == 0 && count2 == 0)
	       countsum += 1;
		valuesum += pow (value, 1);
	}
	
	value2 = archive_size - 1;
	valuesum = (valuesum - countsum) / (value2 - countsum);
	valuesum = pow (valuesum, 1);

	sp = valuesum;

	free (b);
	free (d);
	free (e);  
	for (i = 0; i < archive_size; i++)
    {
        free (c[i]);
    }
	free (c);
	free (closest);
	free (lowcost);

	return sp;
}

